import React from "react";
import evtBus from '@/utils/event_bus';

/**
 * 页面显示, 隐藏 hook, 可以在 component 中使用
 */
export default (fn, deps) => {
  const fnRef = React.useRef();
  fnRef.current = fn;

  const [evt, func] = React.useMemo(() => {
    const evt1 = evtBus.current();
    const func1 = () => fnRef.current();

    evt1.addEventListener('hide', func1);
    evt1.addEventListener('unload', func1);

    return [
      evt1,
      func1,
    ];
  }, []);

  React.useEffect(() => {
    evt.addEventListener('hide', func);
    evt.addEventListener('unload', func);

    return () => {
      evt.removeEventListener('hide', func);
      evt.removeEventListener('unload', func);
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, deps);
}
